#include "mig.h"
#include <mach/mach.h>
#include <mach/message.h>
#include <stdio.h>
#include <stdlib.h>

// use our own implementation of io_connect_set_notification_port so we don't
// need to provide a receive right for the MAKE_SEND and can instead COPY_SEND

kern_return_t io_connect_set_notification_port_copy_send
(
 mach_port_t connection,
 uint32_t notification_type,
 mach_port_t port,
 uint32_t reference
 )
{
  
#ifdef  __MigPackStructs
#pragma pack(4)
#endif
  typedef struct {
    mach_msg_header_t Head;
    /* start of the kernel processed data */
    mach_msg_body_t msgh_body;
    mach_msg_port_descriptor_t port;
    /* end of the kernel processed data */
    NDR_record_t NDR;
    uint32_t notification_type;
    uint32_t reference;
  } Request __attribute__((unused));
#ifdef  __MigPackStructs
#pragma pack()
#endif
  
#ifdef  __MigPackStructs
#pragma pack(4)
#endif
  typedef struct {
    mach_msg_header_t Head;
    NDR_record_t NDR;
    kern_return_t RetCode;
    mach_msg_trailer_t trailer;
  } Reply __attribute__((unused));
#ifdef  __MigPackStructs
#pragma pack()
#endif
  
#ifdef  __MigPackStructs
#pragma pack(4)
#endif
  typedef struct {
    mach_msg_header_t Head;
    NDR_record_t NDR;
    kern_return_t RetCode;
  } __Reply __attribute__((unused));
#ifdef  __MigPackStructs
#pragma pack()
#endif
  /*
   * typedef struct {
   *      mach_msg_header_t Head;
   *      NDR_record_t NDR;
   *      kern_return_t RetCode;
   * } mig_reply_error_t;
   */
  
  union {
    Request In;
    Reply Out;
  } Mess;
  
  Request *InP = &Mess.In;
  Reply *Out0P = &Mess.Out;
  
  mach_msg_return_t msg_result;
  
  kern_return_t check_result;

  
  InP->msgh_body.msgh_descriptor_count = 1;

  InP->port.name = port;
  InP->port.disposition = MACH_MSG_TYPE_COPY_SEND;  // 19
  InP->port.type = MACH_MSG_PORT_DESCRIPTOR;
  
  InP->NDR = NDR_record;
  
  InP->notification_type = notification_type;
  
  InP->reference = reference;
  
  InP->Head.msgh_bits = MACH_MSGH_BITS_COMPLEX|
  MACH_MSGH_BITS(19, MACH_MSG_TYPE_MAKE_SEND_ONCE);
  /* msgh_size passed as argument */
  InP->Head.msgh_remote_port = connection;
  InP->Head.msgh_local_port = mig_get_reply_port();
  InP->Head.msgh_id = 2818;
  InP->Head.msgh_reserved = 0;
  
  
  msg_result = mach_msg(&InP->Head, MACH_SEND_MSG|MACH_RCV_MSG|MACH_MSG_OPTION_NONE, (mach_msg_size_t)sizeof(Request), (mach_msg_size_t)sizeof(Reply), InP->Head.msgh_local_port, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);

  if (msg_result != MACH_MSG_SUCCESS) {
    return msg_result;
  }

  if (Out0P->RetCode != MACH_MSG_SUCCESS) {
    return check_result;
  }
  
  return KERN_SUCCESS;
}
