#ifndef remote_call_h
#define remote_call_h

#include <stdio.h>
#include <mach/mach.h>

enum arg_type {
  ARG_LITERAL,
  ARG_BUFFER,
  ARG_BUFFER_PERSISTENT, // don't free the buffer after the call
  ARG_OUT_BUFFER
};

typedef struct _arg_desc {
  uint32_t type;
  uint32_t value;
  uint32_t length;
} arg_desc;

#define REMOTE_LITERAL(val) &(arg_desc){ARG_LITERAL, (uint32_t)val, (uint32_t)0}
#define REMOTE_BUFFER(ptr, size) &(arg_desc){ARG_BUFFER, (uint32_t)ptr, (uint32_t)size}
#define REMOTE_CSTRING(str) &(arg_desc){ARG_BUFFER, (uint32_t)str, (uint32_t)(strlen(str)+1)}
#define REMOTE_BUFFER_PERSISTENT(ptr, size) &(arg_desc){ARG_BUFFER_PERSISTENT, (uint32_t)ptr, (uint32_t)size}
#define REMOTE_CSTRING_PERSISTENT(str) &(arg_desc){ARG_BUFFER_PERSISTENT, (uint32_t)str, (uint32_t)(strlen(str)+1)}
#define REMOTE_OUT_BUFFER(ptr, size) &(arg_desc){ARG_OUT_BUFFER, (uint32_t)ptr, (uint32_t)size}

void test_thread_control(mach_port_t thread_port);

void test_gadgets(void);

uint32_t thread_call_remote(mach_port_t thread_port, void* fptr, int n_params, ...);

uint32_t task_remote_call(mach_port_t task_port, void* fptr, int n_params, ...);

#endif /* remote_call_h */
