#ifndef remote_memory_h
#define remote_memory_h

#include <stdio.h>

#include <mach/mach.h>

uint32_t
remote_alloc(mach_port_t task_port,
             uint32_t size);

void
remote_free(mach_port_t task_port,
            uint32_t base,
            uint32_t size);

void remote_write_32(mach_port_t task_port,
                     uint32_t remote_address,
                     uint32_t value);

uint32_t remote_read_32(mach_port_t task_port,
                        uint32_t remote_address);

uint32_t
alloc_and_fill_remote_buffer(mach_port_t task_port,
                             uint32_t local_address,
                             uint32_t length);

void
remote_read_overwrite(mach_port_t task_port,
                      uint32_t remote_address,
                      uint32_t local_address,
                      uint32_t length);
#endif /* remote_memory_h */
