#include <stdio.h>
#include <mach/mach.h>

#include "remote_ports.h"

// copy/move the right named by remote_port_name+disposition into this process, returning our name
mach_port_t
pull_remote_port(
                 mach_port_t task_port,
                 mach_port_name_t remote_port_name,
                 mach_port_right_t disposition)     // eg MACH_MSG_TYPE_COPY_SEND
{
  kern_return_t err;
  mach_port_t local_name = MACH_PORT_NULL;
  mach_msg_type_name_t local_rights = 0;
  err = mach_port_extract_right(task_port, remote_port_name, disposition, &local_name, &local_rights);
  if (err != KERN_SUCCESS) {
    printf("unable to extract right from remote task: %x %s\n", err, mach_error_string(err));
    return 0;
  }
  
  return local_name;
}